/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 1128
#ifdef HAVE_CONFIG_H
#line 1128
# include <config.h>
#line 1128
#endif
#line 1128
#include <sys/types.h>
#line 1128

#line 1128
#include "mailfromd.h"
#line 1128
#include "prog.h"
#line 1128
#include "builtin.h"
#line 1128

#line 178 "io.bi"
static mu_debug_handle_t debug_handle;
#line 1128 "io.bi"

#line 767 "../../src/builtin/snarf.m4"

#line 1 "io.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006-2011, 2015-2016 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <mflib/status.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include "global.h"
#include "msg.h"

static size_t nstreams = MAX_IOSTREAMS;

static struct mu_cfg_param io_cfg_param[] = {
	{ "max-streams", mu_c_size, &nstreams, 0, NULL,
	  N_("Maximum number of stream descriptors.") },
	{ NULL }
};

struct io_stream {
	char *name;
	mu_locker_t lock;
	int fd[2];
	pid_t pid;
	char *buf;
	size_t bufsize;
	int (*shutdown)(struct io_stream *, int what);
	void (*cleanup)(void*);
	void *cleanup_data;
	char *delim;
};

#define IFD(s) ((s).fd[0])
#define OFD(s) ((s).fd[1] == -1 ? (s).fd[0] : (s).fd[1])

static void
flush_stream(struct io_stream *str)
{
	/*FIXME*/
}

static void
close_stream(struct io_stream *str)
{
	if (OFD(*str) == -1)
		return;
	flush_stream(str);
	close(OFD(*str));
	if (IFD(*str) != -1)
		close(IFD(*str));
	if (str->pid) {
		int status;
		waitpid(str->pid, &status, 0);
	}
	str->fd[0] = -1;
	str->fd[1] = -1;
	str->pid = 0;
	if (str->cleanup)
		str->cleanup(str->cleanup_data);
	str->cleanup = NULL;
	str->cleanup_data = NULL;
	if (str->name) {
		free(str->name);
		str->name = NULL;
	}
	if (str->delim) {
		free(str->delim);
		str->delim = NULL;
	}
}

/* Read bytes from the stream STR into its buffer, until
   DELIM is encountered. Return number of bytes read. */
static int
read_stream_delim(struct io_stream *str, char *delim)
{
	int fd = IFD(*str);
	size_t i = 0;
	int rc;
	size_t delim_len = strlen(delim);
	
	for (;;) {
		if (str->bufsize == i) {
			if (str->bufsize == 0) 
				str->bufsize = 16;
			str->buf = mu_2nrealloc(str->buf, &str->bufsize,
					      sizeof str->buf[1]);
		}
		rc = read(fd, str->buf + i, 1);
		if (rc == -1)
			return -1;
		else if (rc == 0)
			return 0;
		i++;
		if (i >= delim_len &&
		    memcmp(str->buf + i - delim_len, delim, delim_len) == 0) {
			str->buf[i - delim_len] = 0;
			break;
		}
	}
	return i;
}

#define REDIRECT_STDIN_P(f) ((f) & (O_WRONLY|O_RDWR))
#define REDIRECT_STDOUT_P(f) (!((f) & O_WRONLY))

#define STDERR_SHUT        0
#define STDERR_NULL        1
#define STDERR_LOG         2
#define STDERR_FILE        3
#define STDERR_FILE_APPEND 4

#define LOG_TAG_PFX "mailfromd:"
#define LOG_TAG_PFX_LEN (sizeof(LOG_TAG_PFX)-1)

static void
stderr_to_log(char *arg, const char *cmd)
{
	int p[2];
	pid_t pid;
	
	if (pipe(p)) {
		mu_error(_("pipe failed: %s"), mu_strerror(errno));
		close(2);
		return;
	}

	pid = fork();

	if (pid == (pid_t) -1) {
		mu_error(_("fork failed: %s"), mu_strerror(errno));
		close(p[0]);
		close(p[1]);
		close(2);
		return;
	}
	
	/* Child */
	if (pid == 0) {
		FILE *fp;
		fd_set fdset;
		size_t len;
		char buf[1024];
		char *tag;
		int fac = mu_log_facility, pri = LOG_ERR;
		
		if (arg) {
			char *p = strchr(arg, '.');

			if (p)
				*p++ = 0;
			if (mu_string_to_syslog_facility(arg, &fac)) {
				mu_error(_("unknown syslog facility (%s), "
					   "redirecting stderr to %s"),
					 arg,
					 mu_syslog_facility_to_string(fac));
			}
			
			if (p && mu_string_to_syslog_priority(p, &pri)) {
				mu_error(_("unknown syslog priority (%s), "
					   "redirecting stderr to %s"),
					 arg,
					 mu_syslog_priority_to_string(pri));
			}
		}
		
#line 178 "io.bi"

#line 178
mu_debug(debug_handle, 10,("redirecting stderr to syslog %s.%s",
		           mu_syslog_facility_to_string(fac),
		           mu_syslog_priority_to_string(pri)));
#line 182
		
		len = strcspn(cmd, " \t");
		tag = malloc(LOG_TAG_PFX_LEN + len + 1);
		if (!tag)
			tag = (char*) cmd;
		else {
			strcpy(tag, LOG_TAG_PFX);
			memcpy(tag + LOG_TAG_PFX_LEN, cmd, len);
			tag[LOG_TAG_PFX_LEN + len] = 0;
		}
		mf_proctitle_format("%s redirector", cmd);

		FD_ZERO(&fdset);
		FD_SET(p[0], &fdset);
		logger_fdset(&fdset);
		close_fds_except(&fdset);

		fp = fdopen(p[0], "r");
		logger_open();
		while (fgets(buf, sizeof(buf), fp))
			syslog(pri, "%s", buf);
		exit(0);
	}

	/* Parent */
	close(p[0]);
	dup2(p[1], 2);
	close(p[1]);
}
	
static void
stderr_handler(int mode, char *arg, const char *cmd)
{
	int fd;
	int append = O_TRUNC;
	
	switch (mode) {
	case STDERR_SHUT:
		close(2);
		break;

	case STDERR_NULL:
		arg = "/dev/null";
	case STDERR_FILE_APPEND:
		append = O_APPEND;
	case STDERR_FILE:
		if (!arg || !*arg) {
			close(2);
			break;
		}
		
#line 232

#line 232
mu_debug(debug_handle, 10,("redirecting stderr to %s", arg));
		fd = open(arg, O_CREAT|O_WRONLY|append, 0644);
		if (fd < 0) {
			mu_error(_("cannot open file %s for appending: %s"),
				 arg, mu_strerror(errno));
			close(2);
			return;
		}
		if (fd != 2) {
			dup2(fd, 2);
			close(fd);
		}
		break;

	case STDERR_LOG:
		stderr_to_log(arg, cmd);
	}
}

static void
parse_stderr_redirect(const char **pcmd, int *perr, char **parg)
{
	int err;
	size_t len;
	char *arg;
	const char *cmdline = *pcmd;
	
	while (*cmdline && mu_isspace(*cmdline))
		cmdline++;
	if (strncmp(cmdline, "2>file:", 7) == 0) {
		cmdline += 7;
		err = STDERR_FILE;
	} else if (strncmp(cmdline, "2>>file:", 8) == 0) {
		cmdline += 8;
		err = STDERR_FILE_APPEND;
	} else if (strncmp(cmdline, "2>null:", 7) == 0) {
		cmdline += 7;
		err = STDERR_NULL;
	} else if (strncmp(cmdline, "2>syslog:", 9) == 0) {
		cmdline += 9;
		err = STDERR_LOG;
	} else
		return;

	len = strcspn(cmdline, " \t");
	if (len > 0 && cmdline[len-1] == 0)
		return;
	if (len == 0)
		arg = NULL;
	else {
		arg = malloc(len + 1);
		if (!arg)
			return;
		memcpy(arg, cmdline, len);
		arg[len] = 0;
	}

	*pcmd = cmdline + len;
	*perr = err;
	*parg = arg;
}


static int
open_program_stream_ioe(eval_environ_t env,
			struct io_stream *str, const char *cmdline,
			int flags,
			int ioe[2])
{
	int rightp[2], leftp[2];
	int rc = 0;
	pid_t pid;
	int err = STDERR_SHUT;
	char *arg = NULL;
	struct mu_wordsplit ws;
	
	parse_stderr_redirect(&cmdline, &err, &arg);
	while (*cmdline && (*cmdline == ' ' || *cmdline == '\t'))
		cmdline++;
	
	if (REDIRECT_STDIN_P(flags)) {
		if (pipe(leftp)) {
			mu_diag_funcall(MU_DIAG_ERROR, "pipe", "leftp",
					errno);
			free(arg);
			(
#line 317
	env_throw_bi(env, mfe_failure, NULL, "pipe failed")
#line 317
);
		}
	}
	
	if (REDIRECT_STDOUT_P(flags)) {
		if (pipe(rightp)) {
			mu_diag_funcall(MU_DIAG_ERROR, "pipe", "rightp",
					errno);
			free(arg);
			if (REDIRECT_STDIN_P(flags)) {
				close(leftp[0]);
				close(leftp[1]);
			}
		}
	}
	
	switch (pid = fork()) {
		/* The child branch.  */
	case 0:
		/* attach the pipes */

		/* Right-end */
		if (REDIRECT_STDOUT_P(flags)) {
			if (rightp[1] != 1)
				dup2(rightp[1], 1);
		} else if (ioe && ioe[1] != -1 && ioe[1] != 1) {
			dup2(ioe[1], 1);
		}

		/* Left-end */
		if (REDIRECT_STDIN_P(flags)) {
			if (leftp[0] != 0)
				dup2(leftp[0], 0);
		} else if (ioe && ioe[0] != -1 && ioe[0] != 0) {
			dup2(ioe[0], 0);
		}

		if (ioe && ioe[2] != -1 && ioe[2] != 2)
			dup2(ioe[2], 2);
		else
			stderr_handler(err, arg, cmdline);
		
		/* Close unneded descripitors */
		close_fds_above(2);

		
#line 362

#line 362
mu_debug(debug_handle, 10,("running %s", cmdline));
		if (mu_wordsplit(cmdline, &ws,
				 MU_WRDSF_DEFFLAGS & ~MU_WRDSF_CESCAPES)) {
			mu_error(_("cannot parse command line %s: %s"),
				 cmdline, mu_wordsplit_strerror(&ws));
			exit(127);
		}
		execvp(ws.ws_wordv[0], ws.ws_wordv);
		mu_error(_("cannot run %s: %s"),
			 cmdline, mu_strerror(errno));
		exit(127);
		/********************/

		/* Parent branches: */
	case -1:
		/* Fork has failed */
		/* Restore things */
		rc = errno;
		if (REDIRECT_STDOUT_P(flags)) {
			close(rightp[0]);
			close(rightp[1]);
		}
		if (REDIRECT_STDIN_P(flags)) {
			close(leftp[0]);
			close(leftp[1]);
		}
		break;
		
	default:
		str->pid = pid;
		if (REDIRECT_STDOUT_P(flags)) {
			str->fd[0] = rightp[0];
			close(rightp[1]);
		} else
			str->fd[0] = -1;

		if (REDIRECT_STDIN_P(flags)) {
			str->fd[1] = leftp[1];
			close(leftp[0]);
		} else
			str->fd[1] = -1;
	}
	free(arg);
	return rc;
}

static int
open_program_stream(eval_environ_t env,
		    struct io_stream *str, const char *cmdline,
		    int flags)
{
	return open_program_stream_ioe(env, str, cmdline, flags, NULL);
}

static int
open_file_stream(eval_environ_t env,
		 struct io_stream *str, const char *file, int flags)
{
	str->fd[0] = open(file, flags, 0644); /* FIXME: mode? */
	if (str->fd[0] == -1)
		return errno;
	return 0;
}



static int
open_parsed_inet_stream(eval_environ_t env,
			struct io_stream *str,
			const char *cstr,
			char *proto, char *port, char *path,
			int flags)
{
	union {
		struct sockaddr sa;
		struct sockaddr_in s_in;
		struct sockaddr_un s_un;
#ifdef GACOPYZ_IPV6
		struct sockaddr_in6 s_in6;
#endif
	} addr;

	socklen_t socklen;
	int fd;
	int rc;

	if (!proto
	    || strcmp(proto, "unix") == 0 || strcmp(proto, "local") == 0) {
		struct stat st;
		
			if (!(port == NULL))
#line 452
		(
#line 452
	env_throw_bi(env, mfe_failure, NULL, _("invalid connection type: %s; "
			    "port is meaningless for UNIX sockets"),cstr)
#line 452
)
#line 456
;
		
			if (!(strlen(path) <= sizeof addr.s_un.sun_path))
#line 458
		(
#line 458
	env_throw_bi(env, mfe_range, NULL, _("%s: UNIX socket name too long"),path)
#line 458
)
#line 461
;
		
		addr.sa.sa_family = PF_UNIX;
		socklen = sizeof(addr.s_un);
		strcpy(addr.s_un.sun_path, path);
		
		if (stat(path, &st)) {
			(
#line 468
	env_throw_bi(env, mfe_failure, NULL, _("%s: cannot stat socket: %s"),path,strerror(errno))
#line 468
);
#line 471
		} else {
			/* FIXME: Check permissions? */
				if (!(S_ISSOCK(st.st_mode)))
#line 473
		(
#line 473
	env_throw_bi(env, mfe_failure, NULL, _("%s: not a socket"),path)
#line 473
)
#line 476
;
		}

	} else if (strcmp(proto, "inet") == 0) {
		short pnum;
		long num;
		char *p;
		
		addr.sa.sa_family = PF_INET;
		socklen = sizeof(addr.s_in);

			if (!(port != NULL))
#line 487
		(
#line 487
	env_throw_bi(env, mfe_failure, NULL, _("invalid connection type: %s; "
			    "missing port number"),cstr)
#line 487
)
#line 491
;

		num = pnum = strtol(port, &p, 0);
		if (*p == 0) {
				if (!(num == pnum))
#line 495
		(
#line 495
	env_throw_bi(env, mfe_range, NULL, _("invalid connection type: "
				    "%s; bad port number"),cstr)
#line 495
)
#line 499
;
			pnum = htons(pnum);
		} else {
			struct servent *sp = getservbyname(port, "tcp");

				if (!(sp != NULL))
#line 504
		(
#line 504
	env_throw_bi(env, mfe_failure, NULL, _("invalid connection type: "
				    "%s; unknown port name"),cstr)
#line 504
)
#line 508
;
			pnum = sp->s_port;
		}
		
		if (!path)
			addr.s_in.sin_addr.s_addr = INADDR_ANY;
		else {
			struct hostent *hp = gethostbyname(path);
				if (!(hp != NULL))
#line 516
		(
#line 516
	env_throw_bi(env, mfe_failure, NULL, _("unknown host name %s"),path)
#line 516
)
#line 519
;
			addr.sa.sa_family = hp->h_addrtype;
			switch (hp->h_addrtype) {
			case AF_INET:
				memmove(&addr.s_in.sin_addr, hp->h_addr, 4);
				addr.s_in.sin_port = pnum;
				break;

			default:
				(
#line 528
	env_throw_bi(env, mfe_range, NULL, _("invalid connection type: "
					   "%s; unsupported address family"),cstr)
#line 528
);
#line 532
			}
		}
#ifdef GACOPYZ_IPV6
	} else if (strcmp(proto, "inet6") == 0) {
		struct addrinfo hints;
		struct addrinfo *res;
		
			if (!(port != NULL))
#line 539
		(
#line 539
	env_throw_bi(env, mfe_failure, NULL, _("invalid connection type: %s; "
			    "missing port number"),cstr)
#line 539
)
#line 543
;

		memset(&hints, 0, sizeof(hints));
		hints.ai_family = AF_INET6;
		hints.ai_socktype = SOCK_STREAM;
		if (!path)
			hints.ai_flags |= AI_PASSIVE;
		
		rc = getaddrinfo(path, port, &hints, &res);
				
		switch (rc) {
		case 0:
			break;
			
		case EAI_SYSTEM:
			(
#line 558
	env_throw_bi(env, mfe_failure, NULL, _("%s:%s: cannot parse address: %s"),path,port,strerror(errno))
#line 558
);
#line 561
			
		case EAI_BADFLAGS:
		case EAI_SOCKTYPE:
			(
#line 564
	env_throw_bi(env, mfe_failure, NULL, _("%s:%d: internal error converting %s:%s"),__FILE__,__LINE__,path,port)
#line 564
);
#line 567
			
		case EAI_MEMORY:
			mu_alloc_die();
			
		default:
			(
#line 572
	env_throw_bi(env, mfe_failure, NULL, "%s:%s: %s",path,port,gai_strerror(rc))
#line 572
);
#line 575
		}

		socklen = res->ai_addrlen;
		if (socklen > sizeof(addr)) {
			freeaddrinfo(res);
			(
#line 580
	env_throw_bi(env, mfe_failure, NULL, _("%s:%s: address length too big (%lu)"),path,port,(unsigned long) socklen)
#line 580
);
#line 584
		}
		memcpy(&addr, res->ai_addr, res->ai_addrlen);
		freeaddrinfo(res);
#endif
	} else {
		(
#line 589
	env_throw_bi(env, mfe_range, NULL, _("unsupported protocol: %s"),proto)
#line 589
);
#line 592
	}

	fd = socket(addr.sa.sa_family, SOCK_STREAM, 0);
		if (!(fd != -1))
#line 595
		(
#line 595
	env_throw_bi(env, mfe_failure, NULL, _("unable to create new socket: %s"),strerror(errno))
#line 595
)
#line 598
;

	/* FIXME: Bind to the source ? */

	rc = connect(fd, &addr.sa, socklen);
	if (rc) {
		close(fd);
		(
#line 605
	env_throw_bi(env, mfe_failure, NULL, _("cannot connect to %s: %s"),cstr,strerror(errno))
#line 605
);
#line 608
	}
	
	str->fd[0] = fd;
	return 0;
}

static int
shutdown_inet_stream(struct io_stream *str, int how)
{
	switch (how) {
	case 0:
		how = SHUT_RD;
		break;

	case 1:
		how = SHUT_WR;
		break;

	case 2:
		how = SHUT_RDWR;
		break;

	default:
		return EINVAL;
	}
	if (shutdown(str->fd[0], how))
		return errno;
	return 0;
}

static int
open_inet_stream(eval_environ_t env,
		 struct io_stream *str, const char *addr, int flags)
{
	int rc;
	char *proto, *port, *path;

	if (gacopyz_parse_connection(addr, &proto, &port, &path)
	    != MI_SUCCESS) 
		rc = ENOMEM; /* FIXME: or EINVAL? */
	else {
		rc = open_parsed_inet_stream(env,
					     str, addr,
					     proto, port, path, flags);
		str->shutdown = shutdown_inet_stream;
		free(proto);
		free(port);
		free(path);
	}
	return rc;
}


static void *
alloc_streams()
{
	struct io_stream *p, *stab = mu_calloc(nstreams, sizeof *stab);
	for (p = stab; p < stab + nstreams; p++) 
		p->fd[0] = p->fd[1] = -1;
	return stab;
}

static void
destroy_streams(void *data)
{
	struct io_stream *stab = data;
	struct io_stream *p;
	for (p = stab; p < stab + nstreams; p++) {
		close_stream(p);
		free(p->buf);
	}
	free(stab);
}
		

#line 682

#line 682
static int IO_id;
#line 682 "io.bi"


int
_bi_io_fd(eval_environ_t env, int fd, int what)
{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int descr;

		if (!(fd >= 0 && fd < nstreams && what>=0 && what<=1))
#line 690
		(
#line 690
	env_throw_bi(env, mfe_range, NULL, _("invalid file descriptor"))
#line 690
)
#line 692
;
	descr = what == 0 ? IFD(iotab[fd]) : OFD(iotab[fd]);
		if (!(descr >= 0))
#line 694
		(
#line 694
	env_throw_bi(env, mfe_range, NULL, _("invalid file descriptor"))
#line 694
)
#line 696
;
	return descr;
}


void
#line 701
bi_open(eval_environ_t env)
#line 701

#line 701

#line 701 "io.bi"
{
#line 701
	
#line 701

#line 701

#line 701
char *  name;
#line 701
        
#line 701
get_string_arg(env, 0, &name);
#line 701
        
#line 701

#line 701
        adjust_stack(env, 1);
#line 701

#line 701

#line 701
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 701
		prog_trace(env, "open %s",name);;
#line 701

{
	int i, rc;
	int flags = 0;
	int (*opf)(eval_environ_t env,
		   struct io_stream *, const char *, int) = open_file_stream;
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	
	for (i = 0; i < nstreams; i++) {
		if (iotab[i].fd[0] == -1) 
			break;
	}
		if (!(i < nstreams))
#line 713
		(
#line 713
	env_throw_bi(env, mfe_failure, "open", _("no more files available"))
#line 713
)
#line 715
;

	
#line 717

#line 717
mu_debug(debug_handle, 10,("opening stream %s", name));
	iotab[i].name = mu_strdup(name);
	iotab[i].delim = NULL;
	if (*name == '>') {
		flags |= O_RDWR|O_CREAT;
		name++;
		if (*name == '>') {
			flags |= O_APPEND;
			name++;
		} else
			flags |= O_TRUNC;
	} else if (*name == '|') {
		opf = open_program_stream;
		flags = O_WRONLY;
		name++;
		if (*name == '&') {
			flags = O_RDWR;
			name++;
		} else if (*name == '<') {
			flags = O_RDONLY;
			name++;
		}
	} else if (*name == '@') {
		name++;
		opf = open_inet_stream;
		flags = O_RDWR;
	} else
		flags = O_RDONLY;
	
	for (;*name && mu_isspace(*name); name++)
		;
	
	rc = opf(env, &iotab[i], name, flags);
	
		if (!(rc == 0))
#line 751
		(
#line 751
	env_throw_bi(env, mfe_failure, "open", _("cannot open stream %s: %s"),name,mu_strerror(rc))
#line 751
)
#line 754
;
	
#line 755

#line 755
mu_debug(debug_handle, 10,("open(%s) = %d", name, i));
	
#line 756
do {
#line 756
  push(env, (STKVAL)(mft_number)(i));
#line 756
  goto endlab;
#line 756
} while (0);
}
endlab:
#line 758
        env_function_cleanup_flush(env, NULL);
#line 758
	return;
#line 758
}

void
#line 760
bi_spawn(eval_environ_t env)
#line 760

#line 760

#line 760 "io.bi"
{
#line 760
	
#line 760

#line 760
long __bi_argcnt;
#line 760
char *  name;
#line 760
        long  fin;
#line 760
        long  fout;
#line 760
        long  ferr;
#line 760
        
#line 760
get_string_arg(env, 1, &name);
#line 760
        get_numeric_arg(env, 2, &fin);
#line 760
        get_numeric_arg(env, 3, &fout);
#line 760
        get_numeric_arg(env, 4, &ferr);
#line 760
        
#line 760
get_numeric_arg(env, 0, &__bi_argcnt);
#line 760
        adjust_stack(env, __bi_argcnt + 1);
#line 760

#line 760

#line 760
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 760
		prog_trace(env, "spawn %s %lu %lu %lu",name, ((__bi_argcnt > 1) ? fin : 0), ((__bi_argcnt > 2) ? fout : 0), ((__bi_argcnt > 3) ? ferr : 0));;

{
	int i, rc;
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int ioe[3];
	int flags;
	
	for (i = 0; i < nstreams; i++) {
		if (iotab[i].fd[0] == -1) 
			break;
	}
		if (!(i < nstreams))
#line 772
		(
#line 772
	env_throw_bi(env, mfe_failure, "spawn", _("no more files available"))
#line 772
)
#line 774
;

	
#line 776

#line 776
mu_debug(debug_handle, 10,("spawning %s", name));
	iotab[i].name = mu_strdup(name);
	iotab[i].delim = NULL;

	flags = O_WRONLY;
	if (*name == '|')
		name++;
	if (*name == '&') {
		flags = O_RDWR;
		name++;
	} else if (*name == '<') {
		flags = O_RDONLY;
		name++;
	}

	for (;*name && mu_isspace(*name); name++)
		;

	if ((__bi_argcnt > 1))
		ioe[0] = _bi_io_fd(env, ((__bi_argcnt > 1) ? fin : 0), 0);
	else
		ioe[0] = -1;
	if ((__bi_argcnt > 2))
		ioe[1] = _bi_io_fd(env, ((__bi_argcnt > 2) ? fout : 0), 1);
	else
		ioe[1] = -1;
	if ((__bi_argcnt > 3))
		ioe[2] = _bi_io_fd(env, ((__bi_argcnt > 2) ? fout : 0), 1);
	else
		ioe[2] = -1;
	
	rc = open_program_stream_ioe(env, &iotab[i], name, flags, ioe);
	
		if (!(rc == 0))
#line 809
		(
#line 809
	env_throw_bi(env, mfe_failure, "spawn", _("cannot open stream %s: %s"),name,mu_strerror(rc))
#line 809
)
#line 812
;
	
#line 813

#line 813
mu_debug(debug_handle, 10,("spawn(%s) = %d", name, i));
	
#line 814
do {
#line 814
  push(env, (STKVAL)(mft_number)(i));
#line 814
  goto endlab;
#line 814
} while (0);
	
}
endlab:
#line 817
        env_function_cleanup_flush(env, NULL);
#line 817
	return;
#line 817
}


void
#line 820
bi_tempfile(eval_environ_t env)
#line 820

#line 820

#line 820 "io.bi"
{
#line 820
	
#line 820

#line 820
long __bi_argcnt;
#line 820
char * MFL_DATASEG tempdir;
#line 820
        
#line 820
get_string_arg(env, 1, &tempdir);
#line 820
        
#line 820
get_numeric_arg(env, 0, &__bi_argcnt);
#line 820
        adjust_stack(env, __bi_argcnt + 1);
#line 820

#line 820

#line 820
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 820
		prog_trace(env, "tempfile %s",((__bi_argcnt > 0) ? tempdir : ""));;
#line 820

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int i;
	char *dir = ((__bi_argcnt > 0) ? tempdir : "/tmp");
	size_t dirlen = strlen(dir);
	mode_t u;
	int fd;
	char *template;
#define PATTERN "mfdXXXXXX"

	for (i = 0; i < nstreams; i++) {
		if (iotab[i].fd[0] == -1) 
			break;
	}
		if (!(i < nstreams))
#line 835
		(
#line 835
	env_throw_bi(env, mfe_failure, "tempfile", _("no more files available"))
#line 835
)
#line 837
;


	while (dirlen > 0 && dir[dirlen-1] == '/')
		dirlen--;

	template = mf_c_val(heap_tempspace(env, (dirlen ? dirlen + 1 : 0) +
#line 843
				      sizeof(PATTERN)), ptr);
#line 845
	if (dirlen) {
		memcpy(template, dir, dirlen);
		template[dirlen++] = '/';
	}
	strcpy(template + dirlen, PATTERN);
	u = umask(077);
	fd = mkstemp(template);
	umask(u);
		if (!(fd >= 0))
#line 853
		(
#line 853
	env_throw_bi(env, mfe_failure, "tempfile", "mkstemp failed: %s",mu_strerror(errno))
#line 853
)
#line 856
;
	unlink(template);

	iotab[i].fd[0] = fd;
	
	
#line 861
do {
#line 861
  push(env, (STKVAL)(mft_number)(i));
#line 861
  goto endlab;
#line 861
} while (0);
#undef PATTERN
}
endlab:
#line 864
        env_function_cleanup_flush(env, NULL);
#line 864
	return;
#line 864
}

void
#line 866
bi_close(eval_environ_t env)
#line 866

#line 866

#line 866 "io.bi"
{
#line 866
	
#line 866

#line 866

#line 866
long  fd;
#line 866
        
#line 866
get_numeric_arg(env, 0, &fd);
#line 866
        
#line 866

#line 866
        adjust_stack(env, 1);
#line 866

#line 866

#line 866
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 866
		prog_trace(env, "close %lu",fd);;
#line 866

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);

		if (!(fd >= 0 && fd < nstreams))
#line 870
		(
#line 870
	env_throw_bi(env, mfe_range, "close", _("invalid file descriptor"))
#line 870
)
#line 872
;
	close_stream(&iotab[fd]);
}

#line 875
        env_function_cleanup_flush(env, NULL);
#line 875
	return;
#line 875
}	

static struct builtin_const_trans shutdown_modes[] = {
	{ _MFL_SHUT_RD, SHUT_RD },
	{ _MFL_SHUT_WR, SHUT_WR },
	{ _MFL_SHUT_RDWR, SHUT_RDWR }
};

void
#line 883
bi_shutdown(eval_environ_t env)
#line 883

#line 883

#line 883 "io.bi"
{
#line 883
	
#line 883

#line 883

#line 883
long  fd;
#line 883
        long  how;
#line 883
        
#line 883
get_numeric_arg(env, 0, &fd);
#line 883
        get_numeric_arg(env, 1, &how);
#line 883
        
#line 883

#line 883
        adjust_stack(env, 2);
#line 883

#line 883

#line 883
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 883
		prog_trace(env, "shutdown %lu %lu",fd, how);;
#line 883

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;
	int mode;
	
		if (!(fd >= 0 && fd < nstreams))
#line 889
		(
#line 889
	env_throw_bi(env, mfe_range, "shutdown", _("invalid file descriptor"))
#line 889
)
#line 891
;
		if (!(how >= 0 && how <= 2))
#line 892
		(
#line 892
	env_throw_bi(env, mfe_range, "shutdown", _("invalid file descriptor"))
#line 892
)
#line 894
;
		if (!(_builtin_const_to_c(shutdown_modes,
#line 895
				      MU_ARRAY_SIZE(shutdown_modes),
#line 895
				      how,
#line 895
				      &mode) == 0))
#line 895
		(
#line 895
	env_throw_bi(env, mfe_failure, "shutdown", "bad shutdown mode")
#line 895
)
#line 900
;
	
	ioptr = &iotab[fd];
	if (ioptr->shutdown) {
		int rc = ioptr->shutdown(ioptr, mode);
			if (!(rc == 0))
#line 905
		(
#line 905
	env_throw_bi(env, mfe_io, "shutdown", "shutdown failed: %s",mu_strerror(rc))
#line 905
)
#line 908
;
	} else if (how == 2)
		close_stream(ioptr);
	else if (ioptr->fd[how]) {
		close(ioptr->fd[how]);
		ioptr->fd[how] = -1;
	}
}

#line 916
        env_function_cleanup_flush(env, NULL);
#line 916
	return;
#line 916
}

void
#line 918
bi_write(eval_environ_t env)
#line 918

#line 918

#line 918 "io.bi"
{
#line 918
	
#line 918

#line 918
long __bi_argcnt;
#line 918
long  fd;
#line 918
        char *  str;
#line 918
        long  n;
#line 918
        
#line 918
get_numeric_arg(env, 1, &fd);
#line 918
        get_string_arg(env, 2, &str);
#line 918
        get_numeric_arg(env, 3, &n);
#line 918
        
#line 918
get_numeric_arg(env, 0, &__bi_argcnt);
#line 918
        adjust_stack(env, __bi_argcnt + 1);
#line 918

#line 918

#line 918
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 918
		prog_trace(env, "write %lu %s %lu",fd, str, ((__bi_argcnt > 2) ? n : 0));;
#line 918

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int rc;
	
	
#line 923

#line 923
mu_debug(debug_handle, 10,("writing %s to %lu", str, fd));
		if (!(fd >= 0 && fd < nstreams && OFD(iotab[fd]) != -1))
#line 924
		(
#line 924
	env_throw_bi(env, mfe_range, "write", _("invalid file descriptor"))
#line 924
)
#line 926
;
	if (!(__bi_argcnt > 2))
		n = strlen (str);
	rc = write(OFD(iotab[fd]), str, n);
		if (!(n == rc))
#line 930
		(
#line 930
	env_throw_bi(env, mfe_io, "write", _("write error on %s: %s"),iotab[fd].name,mu_strerror(errno))
#line 930
)
#line 933
;
}

#line 935
        env_function_cleanup_flush(env, NULL);
#line 935
	return;
#line 935
}


void
#line 938
bi_write_body(eval_environ_t env)
#line 938

#line 938

#line 938 "io.bi"
{
#line 938
	
#line 938

#line 938

#line 938
long  fd;
#line 938
        void *  str;
#line 938
        long  n;
#line 938
        
#line 938
get_numeric_arg(env, 0, &fd);
#line 938
        get_pointer_arg(env, 1, &str);
#line 938
        get_numeric_arg(env, 2, &n);
#line 938
        
#line 938

#line 938
        adjust_stack(env, 3);
#line 938

#line 938

#line 938
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 938
		prog_trace(env, "write_body %lu %p %lu",fd, str, n);;
#line 938

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int rc;

		if (!(fd >= 0 && fd < nstreams && OFD(iotab[fd]) != -1))
#line 943
		(
#line 943
	env_throw_bi(env, mfe_range, "write_body", _("invalid file descriptor"))
#line 943
)
#line 945
;
	rc = write(OFD(iotab[fd]), str, n);
		if (!(n == rc))
#line 947
		(
#line 947
	env_throw_bi(env, mfe_io, "write_body", _("write error on %s: %s"),iotab[fd].name,mu_strerror(errno))
#line 947
)
#line 950
;
}

#line 952
        env_function_cleanup_flush(env, NULL);
#line 952
	return;
#line 952
}

void
#line 954
bi_read(eval_environ_t env)
#line 954

#line 954

#line 954 "io.bi"
{
#line 954
	
#line 954

#line 954

#line 954
long  fd;
#line 954
        long  size;
#line 954
        
#line 954
get_numeric_arg(env, 0, &fd);
#line 954
        get_numeric_arg(env, 1, &size);
#line 954
        
#line 954

#line 954
        adjust_stack(env, 2);
#line 954

#line 954

#line 954
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 954
		prog_trace(env, "read %lu %lu",fd, size);;
#line 954

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int rc;
	size_t off;
	char *s = (char*) env_data_ref(env, (off = heap_reserve(env, size + 1)));

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 961
		(
#line 961
	env_throw_bi(env, mfe_range, "read", _("invalid file descriptor"))
#line 961
)
#line 963
;
	
	rc = read(IFD(iotab[fd]), s, size);
	if (rc == 0)
		(
#line 967
	env_throw_bi(env, mfe_eof, "read", _("EOF on %s"),iotab[fd].name)
#line 967
);
#line 969
		if (!(rc == size))
#line 969
		(
#line 969
	env_throw_bi(env, mfe_io, "read", _("read error on %s: %s"),iotab[fd].name,mu_strerror(errno))
#line 969
)
#line 972
;
	s[size] = 0;
	
#line 974
do {
#line 974
  push(env, (STKVAL) (mft_size) (off));
#line 974
  goto endlab;
#line 974
} while (0);
}	
endlab:
#line 976
        env_function_cleanup_flush(env, NULL);
#line 976
	return;
#line 976
}

void
#line 978
bi_rewind(eval_environ_t env)
#line 978

#line 978

#line 978 "io.bi"
{
#line 978
	
#line 978

#line 978

#line 978
long  fd;
#line 978
        
#line 978
get_numeric_arg(env, 0, &fd);
#line 978
        
#line 978

#line 978
        adjust_stack(env, 1);
#line 978

#line 978

#line 978
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 978
		prog_trace(env, "rewind %lu",fd);;
#line 978

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 982
		(
#line 982
	env_throw_bi(env, mfe_range, "rewind", _("invalid file descriptor"))
#line 982
)
#line 984
;
	if (lseek(IFD(iotab[fd]), 0, SEEK_SET) == -1)
		(
#line 986
	env_throw_bi(env, mfe_io, "rewind", "seek failed: %s",mu_strerror(errno))
#line 986
);
#line 989
}

#line 990
        env_function_cleanup_flush(env, NULL);
#line 990
	return;
#line 990
}
	

#define MINBUFSIZE 128
#define MAXBUFSIZE 65535

void
#line 996
bi_copy(eval_environ_t env)
#line 996

#line 996

#line 996 "io.bi"
{
#line 996
	
#line 996

#line 996

#line 996
long  dst;
#line 996
        long  src;
#line 996
        
#line 996
get_numeric_arg(env, 0, &dst);
#line 996
        get_numeric_arg(env, 1, &src);
#line 996
        
#line 996

#line 996
        adjust_stack(env, 2);
#line 996

#line 996

#line 996
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 996
		prog_trace(env, "copy %lu %lu",dst, src);;
#line 996

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	int ifd, ofd;
	char *buffer;
	size_t bufsize = MAXBUFSIZE;
	char bs[MINBUFSIZE];
	off_t cur, end;
	size_t total = 0;
	ssize_t rdbytes;
	
		if (!(src >= 0 && src < nstreams && (ifd = IFD(iotab[src])) != -1))
#line 1007
		(
#line 1007
	env_throw_bi(env, mfe_range, "copy", _("invalid source file descriptor"))
#line 1007
)
#line 1009
;
		if (!(dst >= 0 && dst < nstreams && (ofd = OFD(iotab[dst])) != -1))
#line 1010
		(
#line 1010
	env_throw_bi(env, mfe_range, "copy", _("invalid destination file descriptor"))
#line 1010
)
#line 1012
;

	cur = lseek (ifd, 0, SEEK_CUR);
	if (cur != -1) {
		end = lseek (ifd, 0, SEEK_END);
		if (end != -1) {
			if (end < MAXBUFSIZE)
				bufsize = end;
			lseek (ifd, cur, SEEK_SET);
		}
	}

	for (; (buffer = malloc (bufsize)) == NULL; bufsize >>= 1)
		if (bufsize < MINBUFSIZE) {
			buffer = bs;
			bufsize = MINBUFSIZE;
			break;
		}

	while ((rdbytes = read(ifd, buffer, bufsize)) > 0) {
		char *p = buffer;
		while (rdbytes) {
			ssize_t wrbytes = write(ofd, p, rdbytes);
			if (wrbytes == -1) {
				if (buffer != bs)
					free(buffer);
				(
#line 1038
	env_throw_bi(env, mfe_io, "copy", "write error: %s",mu_strerror(errno))
#line 1038
);
#line 1041
			} else if (wrbytes == 0) {
				if (buffer != bs)
					free(buffer);
				(
#line 1044
	env_throw_bi(env, mfe_io, "copy", "short write")
#line 1044
);
#line 1046
			}
			p += wrbytes;
			rdbytes -= wrbytes;
			total += wrbytes;
		}
	}
	if (buffer != bs)
		free(buffer);
	
#line 1054
do {
#line 1054
  push(env, (STKVAL)(mft_number)(total));
#line 1054
  goto endlab;
#line 1054
} while (0);
}
endlab:
#line 1056
        env_function_cleanup_flush(env, NULL);
#line 1056
	return;
#line 1056
}

void
#line 1058
bi_getdelim(eval_environ_t env)
#line 1058

#line 1058

#line 1058 "io.bi"
{
#line 1058
	
#line 1058

#line 1058

#line 1058
long  fd;
#line 1058
        char * MFL_DATASEG delim;
#line 1058
        
#line 1058
get_numeric_arg(env, 0, &fd);
#line 1058
        get_string_arg(env, 1, &delim);
#line 1058
        
#line 1058

#line 1058
        adjust_stack(env, 2);
#line 1058

#line 1058

#line 1058
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 1058
		prog_trace(env, "getdelim %lu %s",fd, delim);;
#line 1058

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;
	int rc;
	
		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 1064
		(
#line 1064
	env_throw_bi(env, mfe_range, "getdelim", _("invalid file descriptor"))
#line 1064
)
#line 1066
;
	ioptr = &iotab[fd];
	rc = read_stream_delim(ioptr, delim); 
	if (rc == 0)
		(
#line 1070
	env_throw_bi(env, mfe_eof, "getdelim", _("EOF on %s"),ioptr->name)
#line 1070
);
		if (!(rc > 0))
#line 1071
		(
#line 1071
	env_throw_bi(env, mfe_io, "getdelim", _("read error on %s: %s"),ioptr->name,mu_strerror(errno))
#line 1071
)
#line 1074
;
	
#line 1075
do {
#line 1075
  pushs(env, ioptr->buf);
#line 1075
  goto endlab;
#line 1075
} while (0);
}	
endlab:
#line 1077
        env_function_cleanup_flush(env, NULL);
#line 1077
	return;
#line 1077
}

void
#line 1079
bi_getline(eval_environ_t env)
#line 1079

#line 1079

#line 1079 "io.bi"
{
#line 1079
	
#line 1079

#line 1079

#line 1079
long  fd;
#line 1079
        
#line 1079
get_numeric_arg(env, 0, &fd);
#line 1079
        
#line 1079

#line 1079
        adjust_stack(env, 1);
#line 1079

#line 1079

#line 1079
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 1079
		prog_trace(env, "getline %lu",fd);;
#line 1079

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;
	int rc;

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 1085
		(
#line 1085
	env_throw_bi(env, mfe_range, "getline", _("invalid file descriptor"))
#line 1085
)
#line 1087
;
	ioptr = &iotab[fd];
	rc = read_stream_delim(ioptr, ioptr->delim ? ioptr->delim : "\n");
	if (rc == 0)
		(
#line 1091
	env_throw_bi(env, mfe_eof, "getline", _("EOF on %s"),ioptr->name)
#line 1091
);
#line 1093
		if (!(rc > 0))
#line 1093
		(
#line 1093
	env_throw_bi(env, mfe_io, "getline", _("read error on %s: %s"),ioptr->name,mu_strerror(errno))
#line 1093
)
#line 1096
;
	
#line 1097
do {
#line 1097
  pushs(env, ioptr->buf);
#line 1097
  goto endlab;
#line 1097
} while (0);
}	
endlab:
#line 1099
        env_function_cleanup_flush(env, NULL);
#line 1099
	return;
#line 1099
}

void
#line 1101
bi_fd_set_delimiter(eval_environ_t env)
#line 1101

#line 1101

#line 1101 "io.bi"
{
#line 1101
	
#line 1101

#line 1101

#line 1101
long  fd;
#line 1101
        char *  delim;
#line 1101
        
#line 1101
get_numeric_arg(env, 0, &fd);
#line 1101
        get_string_arg(env, 1, &delim);
#line 1101
        
#line 1101

#line 1101
        adjust_stack(env, 2);
#line 1101

#line 1101

#line 1101
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 1101
		prog_trace(env, "fd_set_delimiter %lu %s",fd, delim);;
#line 1101

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 1106
		(
#line 1106
	env_throw_bi(env, mfe_range, "fd_set_delimiter", _("invalid file descriptor"))
#line 1106
)
#line 1108
;
	ioptr = &iotab[fd];
	free(ioptr->delim);
	ioptr->delim = mu_strdup(delim);
}

#line 1113
        env_function_cleanup_flush(env, NULL);
#line 1113
	return;
#line 1113
}

void
#line 1115
bi_fd_delimiter(eval_environ_t env)
#line 1115

#line 1115

#line 1115 "io.bi"
{
#line 1115
	
#line 1115

#line 1115

#line 1115
long  fd;
#line 1115
        char * MFL_DATASEG delim;
#line 1115
        
#line 1115
get_numeric_arg(env, 0, &fd);
#line 1115
        get_string_arg(env, 1, &delim);
#line 1115
        
#line 1115

#line 1115
        adjust_stack(env, 2);
#line 1115

#line 1115

#line 1115
	if (builtin_module_trace(BUILTIN_IDX_io))
#line 1115
		prog_trace(env, "fd_delimiter %lu %s",fd, delim);;
#line 1115

{
	struct io_stream *iotab = env_get_builtin_priv(env,IO_id);
	struct io_stream *ioptr;

		if (!(fd >= 0 && fd < nstreams && IFD(iotab[fd]) != -1))
#line 1120
		(
#line 1120
	env_throw_bi(env, mfe_range, "fd_delimiter", _("invalid file descriptor"))
#line 1120
)
#line 1122
;
	ioptr = &iotab[fd];
	
#line 1124
do {
#line 1124
  pushs(env, ioptr->delim ? ioptr->delim : "\n");
#line 1124
  goto endlab;
#line 1124
} while (0);
}
endlab:
#line 1126
        env_function_cleanup_flush(env, NULL);
#line 1126
	return;
#line 1126
}


#line 1128
void
#line 1128
io_init_builtin()
#line 1128
{
#line 1128
		debug_handle = mu_debug_register_category("bi_io");
#line 1128

#line 1128
	#line 682 "io.bi"
IO_id = builtin_priv_register(alloc_streams, destroy_streams,
#line 682
NULL);
#line 701 "io.bi"
va_builtin_install_ex("open", bi_open, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 760 "io.bi"
va_builtin_install_ex("spawn", bi_spawn, 0, dtype_number, 4, 3, 0|0, dtype_string, dtype_number, dtype_number, dtype_number);
#line 820 "io.bi"
va_builtin_install_ex("tempfile", bi_tempfile, 0, dtype_number, 1, 1, 0|0, dtype_string);
#line 866 "io.bi"
va_builtin_install_ex("close", bi_close, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 883 "io.bi"
va_builtin_install_ex("shutdown", bi_shutdown, 0, dtype_unspecified, 2, 0, 0|0, dtype_number, dtype_number);
#line 918 "io.bi"
va_builtin_install_ex("write", bi_write, 0, dtype_unspecified, 3, 1, 0|0, dtype_number, dtype_string, dtype_number);
#line 938 "io.bi"
va_builtin_install_ex("write_body", bi_write_body, STATMASK(smtp_state_body), dtype_unspecified, 3, 0, 0|0, dtype_number, dtype_pointer, dtype_number);
#line 954 "io.bi"
va_builtin_install_ex("read", bi_read, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_number);
#line 978 "io.bi"
va_builtin_install_ex("rewind", bi_rewind, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 996 "io.bi"
va_builtin_install_ex("copy", bi_copy, 0, dtype_number, 2, 0, 0|0, dtype_number, dtype_number);
#line 1058 "io.bi"
va_builtin_install_ex("getdelim", bi_getdelim, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_string);
#line 1079 "io.bi"
va_builtin_install_ex("getline", bi_getline, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 1101 "io.bi"
va_builtin_install_ex("fd_set_delimiter", bi_fd_set_delimiter, 0, dtype_unspecified, 2, 0, 0|0, dtype_number, dtype_string);
#line 1115 "io.bi"
va_builtin_install_ex("fd_delimiter", bi_fd_delimiter, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_string);

#line 1128 "io.bi"
	
#line 1128
	 mf_add_runtime_params(io_cfg_param);
#line 1128
	 
#line 1128
}
#line 1128 "io.bi"

#line 1130

#line 761 "../../src/builtin/snarf.m4"

#line 761

